KTar class Reference (kio Library)

| # kio Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KTar Class Reference

A class for reading/writing (optionnally compressed) tar archives. More...

`#include <ktar.h>`

Inheritance diagram for KTar:

[legend]
Collaboration diagram for KTar:

[legend]
List of all members.

## Public Member Functions
| KTar (const QString &filename, const QString &mimetype=QString::null)
| Creates an instance that operates on the given filename.
| KTar (QIODevice *dev)
| Creates an instance that operates on the given device.
virtual | ~KTar ()
| If the tar ball is still opened, then it will be closed automatically by the destructor.
QString | fileName ()
| The name of the tar file, as passed to the constructor Null if you used the QIODevice constructor.
void | setOrigFileName (const QCString &fileName)
| Special function for setting the "original file name" in the gzip header, when writing a tar.gz file.
virtual bool | writeDir (const QString &name, const QString &user, const QString &group)
| If an archive is opened for writing then you can add new directories using this function.
virtual bool | prepareWriting (const QString &name, const QString &user, const QString &group, uint size)
| Here's another way of writing a file into an archive: Call prepareWriting, then call device()->writeBlock() (for tar files) or writeData (for zip files) [NEW VIRTUAL METHOD NEEDED] as many times as wanted then call doneWriting( totalSize ) For tar.gz files, you need to know the size before hand, it is needed in the header! For zip files, size isn't used.
virtual bool | doneWriting (uint size)
| Call doneWriting after writing the data.
## Protected Member Functions
virtual bool | openArchive (int mode)
| Opens the archive for reading.
virtual bool | closeArchive ()
| Closes the archive.
virtual void | virtual_hook (int id, void *data)

## Detailed Description

A class for reading/writing (optionnally compressed) tar archives.

Author:
  Torben Weis <weis@kde.org>, David Faure <faure@kde.org>

Definition at line 35 of file ktar.h.

## Constructor & Destructor Documentation

KTar::KTar | ( | const QString & | filename,
|  | const QString & | mimetype = QString::null
| ) |

  | Creates an instance that operates on the given filename. using the compression filter associated to given mimetype. Parameters:
  filename | is a local path (e.g. "/home/weis/myfile.tgz")
  mimetype | "application/x-gzip" or "application/x-bzip2" Do not use application/x-tgz or so. Only the compression layer ! If the mimetype is ommitted, it will be determined from the filename.
Definition at line 49 of file ktar.cpp. References QFile::exists(), KMimeType::findByFileContent(), KMimeType::findByPath(), QFile::getch(), KIO::mimetype(), and QFile::open().

KTar::KTar | ( | QIODevice * | dev | ) |

| Creates an instance that operates on the given device. The device can be compressed (KFilterDev) or not (QFile, etc.). WARNING: don't assume that giving a QFile here will decompress the file, in case it's compressed! Definition at line 115 of file ktar.cpp.

KTar::~KTar | ( |  | ) | `[virtual]`

| If the tar ball is still opened, then it will be closed automatically by the destructor. Definition at line 121 of file ktar.cpp. References KArchive::close(), KArchive::device(), QString::isEmpty(), and KArchive::isOpened().

## Member Function Documentation

QString KTar::fileName | ( |  | ) | `[inline]`

| The name of the tar file, as passed to the constructor Null if you used the QIODevice constructor. Definition at line 67 of file ktar.h. Referenced by prepareWriting().

void KTar::setOrigFileName | ( | const QCString & | fileName | ) |

| Special function for setting the "original file name" in the gzip header, when writing a tar.gz file. It appears when using in the "file" command, for instance. Should only be called if the underlying device is a KFilterDev! Definition at line 131 of file ktar.cpp. References KArchive::device(), KArchive::isOpened(), and KArchive::mode().

bool KTar::writeDir | ( | const QString & | name,
|  | const QString & | user,
|  | const QString & | group
| ) | `[virtual]`

| If an archive is opened for writing then you can add new directories using this function. KArchive won't write one directory twice. Implements KArchive. Definition at line 342 of file ktar.cpp. References QDir::cleanDirPath(), KArchive::device(), QFile::encodeName(), KArchive::isOpened(), QString::length(), QString::local8Bit(), KArchive::mode(), KStdAccel::name(), QString::right(), and QIODevice::writeBlock().

bool KTar::prepareWriting | ( | const QString & | name,
|  | const QString & | user,
|  | const QString & | group,
|  | uint | size
| ) | `[virtual]`

| Here's another way of writing a file into an archive: Call prepareWriting, then call device()->writeBlock() (for tar files) or writeData (for zip files) [NEW VIRTUAL METHOD NEEDED] as many times as wanted then call doneWriting( totalSize ) For tar.gz files, you need to know the size before hand, it is needed in the header! For zip files, size isn't used. Implements KArchive. Definition at line 397 of file ktar.cpp. References QDir::cleanDirPath(), KArchive::device(), QFile::encodeName(), fileName(), KArchive::isOpened(), QString::length(), QString::local8Bit(), KArchive::mode(), KStdAccel::name(), and QIODevice::writeBlock().

bool KTar::doneWriting | ( | uint | size | ) | `[virtual]`

| Call doneWriting after writing the data. See also: prepareWriting Implements KArchive. Definition at line 462 of file ktar.cpp. References KArchive::device(), and QIODevice::writeBlock().

bool KTar::openArchive | ( | int | mode | ) | `[protected, virtual]`

| Opens the archive for reading. Parses the directory listing of the archive and creates the KArchiveDirectory/KArchiveFile entries. Implements KArchive. Definition at line 142 of file ktar.cpp. References KArchiveDirectory::addEntry(), QIODevice::at(), QDir::cleanDirPath(), KArchive::device(), KArchive::findOrCreate(), QString::findRev(), QString::fromLocal8Bit(), QString::left(), QString::length(), QCString::length(), QString::mid(), KStdAccel::name(), QIODevice::readBlock(), QString::right(), KArchive::rootDir(), QCString::sprintf(), and KIO::symlink().

bool KTar::closeArchive | ( |  | ) | `[protected, virtual]`

| Closes the archive. Called by close. Implements KArchive. Definition at line 336 of file ktar.cpp.

The documentation for this class was generated from the following files:

- ktar.h
- ktar.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:23:15 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001